//this file is part of notepad++
//Copyright (C)2003 Don HO <donho@altern.org>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "PluginDefinition.h"

#define NDM_GETSCINTILLAMAIN   (WM_USER+101)
#define NDM_GETSCINTILLASECOND (WM_USER+102)
#define NDM_GETNPPWINDOW       (WM_USER+103)

#ifdef UNICODE
extern "C" __declspec(dllexport) BOOL isUnicode()
{
    return TRUE;
}
#endif //UNICODE

extern FuncItem funcItem[nbFunc];
extern NppData nppData;


BOOL APIENTRY DllMain( HANDLE hModule,
                       DWORD  reasonForCall,
                       LPVOID lpReserved )
{
    switch (reasonForCall)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}


extern "C" __declspec(dllexport) void setInfo(NppData notpadPlusData)
{
	nppData = notpadPlusData;
	commandMenuInit();
}

extern "C" __declspec(dllexport) const TCHAR * getName()
{
	return NPP_PLUGIN_NAME;
}

extern "C" __declspec(dllexport) FuncItem * getFuncsArray(int *nbF)
{
	*nbF = nbFunc;
	return funcItem;
}

extern "C" __declspec(dllexport) void beNotified(SCNotification *notifyCode)
{
}

// Here you can process the Npp Messages
// I will make the messages accessible little by little, according to the need of plugin development.
// Please let me know if you need to access to some messages :
// http://sourceforge.net/forum/forum.php?forum_id=482781
//
extern "C" __declspec(dllexport) LRESULT messageProc(UINT Message, WPARAM wParam, LPARAM lParam)
{/*
	if (Message == WM_MOVE)
	{
		::MessageBox(NULL, "move", "", MB_OK);
	}
*/
	return TRUE;
}


// ============================== Eigenes Fenster zum Nachrichtenaustausch =============================

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);




int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     PSTR szCmdLine, int iCmdShow)
{
    HWND        hWnd;
    MSG         msg;
    WNDCLASSEX  wc;
    wchar_t     *lpszAppName = L"NppWatcher";
    wchar_t     *lpszTitle   = L"Npp-PlugIn";

    wc.cbSize        =  sizeof(WNDCLASSEX);
    wc.style         =  CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   =  WndProc;
    wc.cbClsExtra    =  0;
    wc.cbWndExtra    =  0;
    wc.hInstance     =  hInstance;
    wc.hCursor       =  LoadCursor(NULL,IDC_ARROW);
    wc.hIcon         =  LoadIcon(NULL, IDI_APPLICATION);
    wc.hbrBackground =  (HBRUSH) (COLOR_WINDOW+1);
    wc.lpszClassName =  lpszAppName;
    wc.lpszMenuName  =  lpszAppName;
    wc.hIconSm       =  LoadIcon(NULL, IDI_APPLICATION);

    if( RegisterClassEx(&wc) == 0)
        return 0;

    hWnd = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,
                          lpszAppName,
                          lpszTitle,
                          WS_OVERLAPPEDWINDOW,
                          10,  // 0
                          10,  // 0
                          CW_USEDEFAULT,
                          CW_USEDEFAULT,
                          NULL,
                          NULL,
                          hInstance,
                          NULL);

    if( hWnd == NULL)
        return 0;

    ShowWindow(hWnd, iCmdShow); // nur zum Test - sonst verstecken, Befehl auskommentieren
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0) > 0)
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT umsg, WPARAM wParam, LPARAM lParam)
{
    switch (umsg)
    {
        case NDM_GETSCINTILLAMAIN:
            return (LPARAM)nppData._scintillaMainHandle;

 		case NDM_GETSCINTILLASECOND:
            return (LPARAM)nppData._scintillaSecondHandle;

		case NDM_GETNPPWINDOW:
            return (LPARAM)nppData._nppHandle;
/*
        // alternativ ausschlielich das Current-Handle holen
        case NPPM_GETCURRENTSCINTILLA:
        {
            int which = -1;
            ::SendMessage(nppData._nppHandle, NPPM_GETCURRENTSCINTILLA, 0, (LPARAM)&which);
            if (which == -1)
                return which;
            HWND curScintilla = (which == 0)?nppData._scintillaMainHandle:nppData._scintillaSecondHandle;
            return (LPARAM)curScintilla;
        }
*/
        case WM_DESTROY:
        {
            PostQuitMessage(0);
            return 0;
        }
    }
    return DefWindowProc(hWnd, umsg, wParam, lParam);
}




